import Mastodon from "mastodon-api";
import fs from "fs";

export class MastodonHandler extends Mastodon{
    postStatus(status){
        this.post('statuses', {status: status}).then((resp) => {
            console.log("status posted => ");
            console.log(resp.data);
        });
    }
    postMedia(status, mediaPath){
        this.post('media', { file: fs.createReadStream(mediaPath) }).then(resp => {
            let id = resp.data.id;
            console.log("media uploaded => ");
            console.log(resp.data);
            this.post('statuses', { status: status, media_ids: [id] }).then((resp) => {
                console.log("media posted => ");
                console.log(resp.data);
            });
        });
    }
}